---
title: |
    Descente de Gradient
    ![](./figs/f/graph.svg)
subtitle: ISC_423
author:
    - Aliya Myaz
    - Omar Alkheja
    - Iliya Saroukhanian
lang: fr-CH
date: \today
documentclass: report
toc: true
listings: true
urlcolor: blue
---

# Introduction

Dans le cadre de ce travail pratique, nous étions amenés à nous familiariser
avec le concept de la descente de gradient dans le contexte de l’apprentissage
machine et l’intelligence artificielle.

La descente de gradient (le concept en lui-même ainsi que les divers
algorithmes) sont utilisés dans l’entraînement des réseaux neuronaux lors de la
rétropropagation ("Backpropagation"). En bref, la rétropropagation consiste à
"remonter" dans le réseau depuis la couche de sortie en direction de la couche
d’entrée afin d’ajuster les poids de chaque neurones qui ont contribué à un
résultat faussé de sorte à pouvoir corriger le réseau. Cette correction
s’effectue grâce à une descente de gradient sur une fonction, dite de "coût",
qui représente l’erreur commise lors d’une mauvaise classification.

# Expérimentation

À présent, nous allons présenter les diverses expériences effectuées, notamment
en ce qui concerne l'ajustement du **_learning rate_** (taux d'apprentissage)
$\lambda$ qui correspond donc à la taille du pas effectué à chaque itération des
des diverses méthodes de descente. Ceci sera illustré principalement à travers
la descente **simple**.

Dans un second temps, nous présenterons l'impact du paramètre **_momentum_**
(inertie) $\gamma$ dans le cadre de la descente **Momentum**. À la suite de ceci,
nous tenterons de faciliter la visualisation de la méthode **Nesterov** en la
comparant immédiatement à la **Momentum**.

Par la suite, nous introduirons la méthode la plus élaborée de quatres
présentées dans ce travail pratique, celle d'**Adam**. Initialement, nous allons
tenter d'étudier l'effet du _learning rate_ $\lambda$ sur cet algorithme et les
raisons pour lesquelles sa valeur devra diverger par rapport aux trois autres
méthodes.

En suite, nous tenterons de jouer avec les deux paramètres specifiques à
**Adam**, $\beta_{1}$ et $\beta_{2}$, afin d'essayer de visualiser la manière
dont ces deux paramètres permettent de rendre le _learning rate_ dynamique
(c'est-à-dire l'ajuster en fonction des asymétries possiblement introduites par
un gradient plus prononcé dans une des dimensions par rapport aux autres). Cette
notion de taux d'apprentissage dynamique provient de l'algorithme **RMSProp**
(_Root Mean Square Propagation_) qui en calculant la moyenne des carrés des
composantes du gradient permet d'établir un taux d'apprentissage variable par
composante.

Les paramètres d'**Adam** permettent aussi d'émuler un comportement d'inertie
présent dans les méthodes **Momentum** et **Nesterov** à l'aide d'un calcul
des moyennes mobiles.

En somme, **Adam** est censé représente le meilleur des deux mondes (taux
d'apprentissage variable par composante et inertie afin de pouvoir passer
au-delà de certains minimums locaux dans le but d'en trouver un global).


<!-- ## test -->
<!-- ![](./figs/f/lr_1e-3.png) -->
<!---->
<!---->
<!-- # Présentations des résultats -->
<!---->
<!-- ## Fonction "bol" -->
<!---->
<!-- Les captures d'écran ci-dessous montrent les diverses méthodes de descente -->
<!-- effectuées sur la fonction : -->
<!---->
<!-- $$ -->
<!-- f(x, y) = x^2 + 5y^2 -->
<!-- $$ -->
<!---->
<!-- ![Graphique de $f(x, y)$](./figs/f/graph.png){width=80%} -->
<!---->
<!-- ![Chemin des descentes sur $f(x, y)$](./figs/f/topology.png){width=80%} -->
<!---->
<!-- \newpage -->
<!---->
<!-- ## Fonction "puit" -->
<!---->
<!-- Point initial = $(1, 1)$ -->
<!---->
<!-- $$ -->
<!-- g(x, y) = 1 - \exp(-10x^2 - y^2) -->
<!-- $$ -->
<!---->
<!-- ![Graphique de $g(x, y)$](./figs/puit/graph.png){width=80%} -->
<!---->
<!-- ![Chemins des descentes sur $g(x, y)$](./figs/puit/topology.png){width=80%} -->
<!---->
<!-- ## Fonction de Rosenbrock -->
<!---->
<!-- $$ -->
<!-- \text{Rosenbrock}(x, y) = (1 - x)^2 + (y - x^2)^2 -->
<!-- $$ -->
<!---->
<!-- ![Graphique de $\text{Rosenbrock}(x, y)$](./figs/rosenbrock/graph.png){width=100%} -->
<!---->
<!-- ![Chemins des descentes sur $\text{Rosenbrock}(x, y)$](./figs/rosenbrock/topology.png){width=100%} -->
<!---->
<!-- ## Fonction de Ackley -->
<!---->
<!-- $$ -->
<!-- \text{Ackley}(x, y) = -20\exp\left[-0.2\sqrt{0.5(x^2 + y^2)}\right] - \exp\left[0.5(\cos 2\pi x + \cos 2\pi y)\right] + e + 20 -->
<!-- $$ -->
<!---->
<!---->
<!-- ![Chemins des descentes sur $\text{Rosenbrock}(x, y)$](./figs/f/graph.svg){width=100%} -->
